# Vấn Đề Kỳ Lạ Trong C++


Một vấn đề lập trình C++ vô cùng ly kỳ đã xảy ra với tôi tối nay. Có lẽ do đã quá lâu rồi không đụng đến C++ (khoảng 5-6 năm trời!), khiến tôi gần như quên sạch những quy tắc cú pháp quái gở đặc trưng của ngôn ngữ này. Hãy cùng nhau giải mã hiện tượng kỳ lạ này nhé!

Sự tình bắt đầu khi tôi cố gắng cài đặt module Perl Syntax::Highlight::Universal. Thật ra chuyện này rất đơn giản với CPAN, chỉ cần gõ lệnh "install" là xong. Nhưng đời không như mơ, quá trình biên dịch cứ chết dí ở bước make. Sau khi mổ xẻ hàng trăm dòng log lỗi cùng đống source code, tôi nhận ra vấn đề nằm ở đoạn mã mẫu rút gọn sau:

template <typename T>
class A {
protected:
    int a;
};

template <typename T>
class B : public A<T> {
public:
    void foo() {
        a = 0;  // Lỗi kỳ quái tại đây!
    }
};

Trông thì có vẻ không vấn đề gì, nhưng khi biên dịch bằng GCC, lập tức nhận về thông báo ám ảnh:
"error: 'a' was not declared in this scope"

Điều kỳ lạ là nếu bỏ cái template <typename T> đi, để A trở thành class thường thì mọi chuyện liền giải quyết êm xuôi. Tôi đã thử đủ mọi cách từ đổi phiên bản GCC 3.x/4.x đến kiểm tra lại cú pháp ba lần, nhưng kết quả vẫn dậm chân tại chỗ.

Sau khi tra cứu tài liệu và thực nghiệm, tôi phát hiện ra đây là một quy tắc ngầm trong lập trình hướng template. Khi kế thừa từ một lớp mẫu (template class), các thành viên protected/public của lớp cha sẽ không tự động được "kế thừa phạm vi" (scope inheritance) trừ khi có lời khai báo rõ ràng. Vì thế đoạn code phải sửa thành:

void foo() {
    this->a = 0;  // Hoặc A<T>::a = 0;
}

Hiện tượng này liên quan mật thiết đến cơ chế biên dịch hai giai đoạn của template:
1. Giai đoạn 1 (Parsing phase): Chỉ phân tích cấu trúc tổng thể, chưa biết kiểu cụ thể
2. Giai đoạn 2 (Instantiation phase): Xác định kiểu dữ liệu và kiểm tra ngữ nghĩa chi tiết

Lúc giai đoạn 1, trình biên dịch không thể biết rõ A<T> sẽ chứa những gì vì chưa biết T là kiểu dữ liệu nào. Việc thêm this-> sẽ buộc trình biên dịch dời việc tìm kiếm định danh 'a' sang giai đoạn 2, khi mà các thông tin về lớp cơ sở đã rõ ràng hơn.

Điều thú vị là Visual C++ 6.0 lại cho phép cú pháp gốc hoạt động. Điều này không phải vì VC6 thông minh hơn, mà ngược lại - đó là do nó xử lý template theo kiểu "lazy parsing" chứ chưa tuân thủ nghiêm ngặt chuẩn C++.

Và bây giờ tôi đã hiểu tại sao mấy năm trước khi viết C++, mình luôn có thói quen viết this-> mỗi khi truy cập biến thành viên. Không chỉ giúp tránh lỗi scope này, mà còn khiến code rõ ràng hơn khi phân biệt biến cục bộ và biến thành viên. Đây thật sự là một bài học nhớ đời về sự khác biệt tinh tế giữa các compiler và tầm quan trọng của việc nắm rõ cơ chế template instantiation!

---

> Tác giả:   
> URL: http://apkpm.com/posts/01/cpp_template/  

